library(purrr)

urls <- c(
  "automobiles" = "http://archive.ics.uci.edu/ml/machine-learning-databases/autos/imports-85.data", 
  "adults" = "https://archive.ics.uci.edu/ml/machine-learning-databases/adult/adult.data",
  "carEvaluation" = "https://archive.ics.uci.edu/ml/machine-learning-databases/car/car.data",
  "habermanSurvival" = "https://archive.ics.uci.edu/ml/machine-learning-databases/haberman/haberman.data"
)
path <- paste0(names(urls), ".data")

delay_by <- function(f, amount) {
  force(f)
  force(amount)
  
  function(...) {
    Sys.sleep(amount)
    f(...)
  }
}


dot_every <- function(f, n) {
  force(f)
  force(n)
  i <- 0
  function(...) {
    i <<- i + 1
    if (i %% n == 0) cat(".")
    f(...)
  }
}

walk2(
 urls, path, 
 dot_every(delay_by(download.file, 0.1), 2),
 quiet = TRUE
)

cat("\n")
